unit BancoDados;

interface
uses udtmBancoDados, Classes, SQLExpr, SysUtils;


type
  TBancoDados = class
  strict private
    dtmBancoDados:TdtmBancoDados;

    constructor Create;
    destructor Destroy;
  class var
    FInstance:TBancoDados;

  public
    class function GetInstance: TBancoDados;
    class procedure FreeSingletonInstance;

    function ConectarBancoDados: Boolean;
    function RetornaConexao: TSQLConnection;
  class var
    AOwner:TComponent;
  end;

implementation

function TBancoDados.ConectarBancoDados: Boolean;
begin
  Result := dtmBancoDados.Conectar;
end;

constructor TBancoDados.Create;
begin
  inherited;
  dtmBancoDados := TdtmBancoDados.Create(AOwner);
end;

destructor TBancoDados.Destroy;
begin
  FreeAndNil(dtmBancoDados);
  inherited Destroy;
end;

class procedure TBancoDados.FreeSingletonInstance;
begin
  FreeAndNil(FInstance);
end;

class function TBancoDados.GetInstance: TBancoDados;
begin
  If FInstance = nil Then
  begin
    FInstance := TBancoDados.Create();
  end;
  Result := FInstance;
end;

function TBancoDados.RetornaConexao: TSQLConnection;
begin
  Result := dtmBancoDados.conPrincipal;
end;

end.
