unit FTransfer;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ScktComp, ComCtrls, ExtCtrls;

type
  TForm2 = class(TForm)
    GroupBox1: TGroupBox;
    Button1: TButton;
    ListBox1: TListBox;
    ClientSocket1: TClientSocket;
    ProgressBar1: TProgressBar;
    Label1: TLabel;
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ClientSocket1Read(Sender: TObject; Socket: TCustomWinSocket);
    procedure ClientSocket1Error(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form2: TForm2;
  ReceivingMode:boolean=false;
  Asked:boolean=false;
  Folder:string;
  Nome:string;
  Size:integer;
  FTransf:TFileStream;
  inicio,tempo:integer;

implementation

Uses MainFrm;

{$R *.dfm}

function RoundN(m:extended):integer;
begin

if m-Trunc(m) > 0.5 then
Result := Trunc(m)+1
else
Result := Trunc(m);

end;

procedure TForm2.FormCreate(Sender: TObject);
begin
Form2.Button1.Align := alClient;
Folder := ExtractFilePath(Application.ExeName)+'\ChatFiles\';
end;

procedure TForm2.Button1Click(Sender: TObject);
begin

if ListBox1.ItemIndex >= 0 then
begin
if not Asked then
begin
Nome := ListBox1.Items.Strings[ListBox1.ItemIndex];
ClientSocket1.Socket.SendText(ListBox1.Items.Strings[ListBox1.ItemIndex]);
ListBox1.Enabled := False;
Button1.Enabled := False;
ProgressBar1.Position := 0;
Asked := True;
end;
end;

end;

procedure TForm2.ClientSocket1Read(Sender: TObject;
  Socket: TCustomWinSocket);
var
info:string;
buffer:PChar;
nReceived:integer;
begin

if Asked then
begin

if not ReceivingMode then
begin

info := Socket.ReceiveText;

if info <> '-1' then
begin

if not DirectoryExists(Folder) then
CreateDir(Folder);

FTransf := TFileStream.Create(Folder+Nome,fmCreate);

Size := strtoint(info);

ProgressBar1.Max := Size-1;

{CONTAGEM DE TEMPO}
inicio := GetTickCount;
tempo := GetTickCount;
Label1.Caption := 'Tempo restante: 99:99:99';
{END}

ReceivingMode := True;

end
else
begin
MessageDlg('O arquivo no foi encontrado.',mtError,[mbOK],0);
Size := 0;
Nome := '';
ReceivingMode := False;
Asked := False;
ListBox1.Enabled := True;
Button1.Enabled := True;
end;

end
else
begin

nReceived := Socket.ReceiveBuf(Buffer,SizeOf(Buffer));
FTransf.Write(Buffer,nReceived);

ProgressBar1.Position := FTransf.Size;

if FTransf.Size = Size then
begin

FTransf.Free;
Size := 0;
Nome := '';
ReceivingMode := False;
Asked := False;
ListBox1.Enabled := True;
Button1.Enabled := True;

end;

end;

end;

end;


function FormatTime(iTheTime: Integer): string;
var
  iHours,
  iMins,
  iSecs: Integer;
begin
  if iTheTime > 0 then
  begin
    iMins   := (iTheTime div 60);
    iSecs   := (iTheTime mod 60);
    iHours  := (iMins div 60);
    iMins   := (iMins mod 60);
    Result  := Format('%.2d:%.2d:%.2d',[iHours, iMins, iSecs]);
  end else
    Result  := '00:00:00';
end;


{function FormatTime(iTheTime: Integer): string;
var
//  iHours,
  iMins,
  iSecs: Integer;
begin
  if iTheTime > 0 then
  begin
    iMins   := (iTheTime div 60);
    iSecs   := (iTheTime mod 60);
//    iHours  := (iMins div 60);
    iMins   := (iMins mod 60);
    Result  := Format('%.2d:%.2d',[iMins, iSecs]);
  end else
    Result  := '00:00';
end;    }


procedure TForm2.ClientSocket1Error(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin
ErrorCode := 0;
end;

procedure TForm2.Timer1Timer(Sender: TObject);
var
segundos:integer;
begin

if ReceivingMode then
begin
{CONTAGEM DE TEMPO}
try
tempo := GetTickCount;
segundos := RoundN((((tempo-inicio)/1000)*(Size-FTransf.Size))/FTransf.Size);
Label1.Caption := 'Tempo restante: '+FormatTime(segundos)+' '+IntToStr(RoundN((FTransf.Size/1024)/((tempo-inicio)/1000)))+'kb/s';
except
Label1.Caption := 'Tempo restante: infinito';
end;
{END}
end;

end;

end.
