unit MainFrm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ScktComp, Buttons;

type
  TForm1 = class(TForm)
    Mensagens: TMemo;
    ClientSocket1: TClientSocket;
    Panel1: TPanel;
    Edit1: TEdit;
    SpeedButton1: TSpeedButton;
    Splitter1: TSplitter;
    procedure FormCreate(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure SpeedButton1Click(Sender: TObject);
    procedure ClientSocket1Read(Sender: TObject; Socket: TCustomWinSocket);
    procedure ClientSocket1Connect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientSocket1Error(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure FormActivate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure ClientSocket1Disconnect(Sender: TObject;
      Socket: TCustomWinSocket);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  nick:string='';

implementation

uses FTransfer;

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
SpeedButton1.Align := alRight;
Edit1.Align := alClient;
end;

procedure TForm1.Edit1KeyPress(Sender: TObject; var Key: Char);
begin


if (Key=#13) then
begin
if Edit1.Text <> '' then
begin
Mensagens.Lines.Add(' Voc diz: '+Edit1.Text);
ClientSocket1.Socket.SendText(nick+'::'+Edit1.Text);
Edit1.Clear;
end;
Key := #0;
end;

end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
Form2.Show;
end;

procedure TForm1.ClientSocket1Read(Sender: TObject;
  Socket: TCustomWinSocket);
var
info:string;
extract:string;
user:string;
begin

info := Socket.ReceiveText;
extract := Copy(info,Pos('::',info)+2,Length(info)-(Pos('::',info)+2)+1);
user := Copy(info,1,Pos('::',info)-1);

if Pos('LIST::',info) = 1 then
begin
Form2.ListBox1.Items.Text := extract;
Exit;
end;

if Pos('NICK::',info) = 1 then
begin
Mensagens.Lines.Add('- Usurio '+extract+' se conectou.');
Exit;
end;

if Pos('NICK::',info) = 1 then
begin
Mensagens.Lines.Add('- Usurio '+extract+' se desconectou.');
Exit;
end;

if (user <> 'LIST') and (user <> 'EXIT') and (user <> 'NICK') then
Mensagens.Lines.Add(' '+user+' diz: '+extract);

end;

procedure TForm1.ClientSocket1Connect(Sender: TObject;
  Socket: TCustomWinSocket);
begin

Socket.SendText('NICK::'+nick);

end;

procedure TForm1.ClientSocket1Error(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin

if ErrorCode = 10061 then
begin
MessageDlg('No foi possvel conectar ao servidor.',mtError,[mbOK],0);
Application.Terminate;
end;

ErrorCode := 0;

end;

procedure TForm1.FormActivate(Sender: TObject);
begin

if nick = '' then
begin

nick := InputBox('Definir Nick','Por favor, insira um nick vlido:','');

while (nick = '') or (nick = 'NICK') or (nick = 'EXIT') or (nick = 'LIST') do
nick := InputBox('Definir Nick','Por favor, insira um nick vlido:','');

if nick <> '' then
begin

ClientSocket1.Active := True;
Form2.ClientSocket1.Active := True;

end;

end;

end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
ClientSocket1.Socket.SendText('EXIT::'+nick);
end;

procedure TForm1.ClientSocket1Disconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
MessageDlg('A conexo com o servidor foi encerrada. Tente novamente mais tarde.',mtError,[mbOk],0);
Application.Terminate;
end;

end.
