unit MainFrm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ScktComp, Buttons, ThdTimer, FileCtrl;

type
  TForm1 = class(TForm)
    Mensagens: TMemo;
    Splitter1: TSplitter;
    ServerSocket1: TServerSocket;
    ServerSocket2: TServerSocket;
    ThreadedTimer1: TThreadedTimer;
    FileListBox1: TFileListBox;
    Timer1: TTimer;
    procedure ServerSocket1ClientRead(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerSocket1ClientError(Sender: TObject;
      Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
      var ErrorCode: Integer);
    procedure FormCreate(Sender: TObject);
    procedure ServerSocket2ClientRead(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerSocket2ClientDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ThreadedTimer1Timer(Sender: TObject);
    procedure ServerSocket2ClientError(Sender: TObject;
      Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
      var ErrorCode: Integer);
    procedure ServerSocket1ClientConnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

type
TUser=record
sindex:integer;
st:TMemoryStream;
pos:integer;
end;
type
TUsers = array of TUser;

var
  Form1: TForm1;
  nick:string='';
  users:TUsers;
  folder:string;

implementation

{$R *.dfm}

function FileSize(fileName : wideString) : Int64;
var
  sr : TSearchRec;
begin
  if FindFirst(fileName, faAnyFile, sr ) = 0 then
     result := Int64(sr.FindData.nFileSizeHigh) shl Int64(32) + Int64(sr.FindData.nFileSizeLow)
  else
     result := -1;

  FindClose(sr) ;
end;


procedure DeleteArrayItem(var X: TUsers; const Index: Integer) ;
begin
   if Index > High(X) then Exit;
   if Index < Low(X) then Exit;
   if Index = High(X) then
   begin
     SetLength(X, Length(X) - 1) ;
     Exit;
   end;
   Finalize(X[Index]) ;
   System.Move(X[Index +1], X[Index],(Length(X) - Index -1) * SizeOf(string) + 1) ;
   SetLength(X, Length(X) - 1) ;
end;


procedure TForm1.ServerSocket1ClientRead(Sender: TObject;
  Socket: TCustomWinSocket);
var
info:string;
extract,user:string;
i:integer;
begin

info := Socket.ReceiveText;



if Pos('NICK::',info) = 1 then
begin

extract := Copy(info,Pos('::',info)+2,Length(info)-(Pos('::',info)+2)+1);

for i:=0 to ServerSocket1.Socket.ActiveConnections-1 do
begin

ServerSocket1.Socket.Connections[i].SendText('NICK::'+extract);

end;

Mensagens.Lines.Add('- Usurio ('+Socket.RemoteAddress+') '+extract+' se conectou.');

Exit;

end;




if Pos('EXIT::',info) = 1 then
begin

extract := Copy(info,Pos('::',info)+2,Length(info)-(Pos('::',info)+2)+1);

for i:=0 to ServerSocket1.Socket.ActiveConnections-1 do
begin

ServerSocket1.Socket.Connections[i].SendText('EXIT::'+extract);

end;

Mensagens.Lines.Add('- Usurio ('+Socket.RemoteAddress+') '+extract+' se desconectou.');

Exit;

end;


extract := Copy(info,Pos('::',info)+2,Length(info)-(Pos('::',info)+2)+1);
user := Copy(info,1,Pos('::',info)-1);

for i:=0 to ServerSocket1.Socket.ActiveConnections-1 do
begin

if ServerSocket1.Socket.Connections[i] <> Socket then
ServerSocket1.Socket.Connections[i].SendText(info);

end;

Mensagens.Lines.Add(' '+user+' ('+Socket.RemoteAddress+') diz: '+extract);


end;

procedure TForm1.ServerSocket1ClientError(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin
ErrorCode:=0;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
Folder := ExtractFilePath(Application.ExeName)+'\ChatFiles\';
if not DirectoryExists(Folder) then
CreateDir(Folder);
FileListBox1.Directory := Folder;
end;

function GetIndex(Socket: TCustomWinSocket):integer;
var
i:integer;
begin

Result := -1;

for i:=0 to Form1.ServerSocket2.Socket.ActiveConnections-1 do
begin

if Form1.ServerSocket2.Socket.Connections[i] = Socket then
Result := i;

end;

end;

procedure TForm1.ServerSocket2ClientRead(Sender: TObject;
  Socket: TCustomWinSocket);
var
info:string;
begin

info := Socket.ReceiveText;

if FileExists(Folder+info) then
begin

SetLength(users,Length(users)+1);

users[Length(users)-1].sindex := GetIndex(Socket);
users[Length(users)-1].st := TMemoryStream.Create;
users[Length(users)-1].st.LoadFromFile(Folder+info);
users[Length(users)-1].pos := 0;

end;

Socket.SendText(IntToStr(FileSize(Folder+info)));

end;

procedure TForm1.ServerSocket2ClientDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
var
i:integer;
begin

for i:=Low(users) to High(users) do
begin

if users[i].sindex = GetIndex(Socket) then
begin
DeleteArrayItem(users,i);
Exit;
end;

end;

end;

procedure TForm1.ThreadedTimer1Timer(Sender: TObject);
var
i,j:integer;
buffer:PChar;
read:integer;
begin

if Length(users) > 0 then
begin

for i:=Low(users) to High(users) do
begin

Application.ProcessMessages;

users[i].st.Position := users[i].pos;

if users[i].st.Size-users[i].st.Position > SizeOf(buffer) then
read:=users[i].st.Read(buffer,SizeOf(buffer))
else
read:=users[i].st.Read(buffer,users[i].st.Size-users[i].st.Position);

users[i].pos := users[i].pos+read;

for j:=0 to ServerSocket2.Socket.ActiveConnections-1 do
begin
if GetIndex(ServerSocket2.Socket.Connections[j]) = users[i].sindex then
begin
ServerSocket2.Socket.Connections[j].SendBuf(Buffer,SizeOf(buffer));
Break;
end;
end;

if users[i].pos >= users[i].st.Size then
begin
users[i].st.Free;
DeleteArrayItem(users,i);
end;

end;

end;

end;

procedure TForm1.ServerSocket2ClientError(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin

//Erro 10053 = client desconectou no meio da mensagem
ErrorCode := 0;

end;

procedure TForm1.ServerSocket1ClientConnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
Socket.SendText('LIST::'+FileListBox1.Items.Text);
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
i:integer;
begin

FileListBox1.Update;

for i:=0 to ServerSocket1.Socket.ActiveConnections-1 do
ServerSocket1.Socket.Connections[i].SendText('LIST::'+FileListBox1.Items.Text);

end;

end.
