unit uDLLAccsses;

interface

uses
  Classes, Controls, SysUtils, StrUtils, DateUtils, Math, Windows,
  Forms, Dialogs;

type

  TGenericDLLAccsses = procedure; stdcall;
  TAbout = procedure (aParent : TWinControl); stdcall;

  TDLLAccsses = class
  private
    oHandle : THandle;
  public
    function InitializeDLL : Boolean;
    procedure ReleaseDLL;
    procedure ShowPacientForm;
    procedure ShowMedicoForm;
    procedure ShowProntuarioForm;
    procedure ShowAbout(aParent : TWinControl);

  end;

implementation

{ TDLLAccsses }

function TDLLAccsses.InitializeDLL: Boolean;
var
  vInitializeDLL : TGenericDLLAccsses;
begin
  Result := False;
  if (oHandle = 0) then begin
    oHandle := LoadLibrary(PChar(ExtractFilePath(Application.ExeName) + 'ProntuarioDLL.dll'));
    if (oHandle <> 0) then begin
      Result := True;
      @vInitializeDLL := GetProcAddress(oHandle, 'InitializeDLL');
      if Assigned(vInitializeDLL) then begin
        vInitializeDLL;
      end;
    end;
  end
  else begin
    Result := True;
  end;
end;

procedure TDLLAccsses.ReleaseDLL;
var
  vReleaseDLL : TGenericDLLAccsses;
begin
  if Self.InitializeDLL then begin
    @vReleaseDLL := GetProcAddress(oHandle, 'ReleaseDLL');
    if Assigned(vReleaseDLL) then begin
      vReleaseDLL;
      FreeLibrary(oHandle);
      oHandle := 0;
    end;
  end;
end;

procedure TDLLAccsses.ShowAbout(aParent: TWinControl);
var
  vShowAboutForm : TAbout;
begin
  if Self.InitializeDLL then begin
    @vShowAboutForm := GetProcAddress(oHandle, 'ShowAbout');
    if Assigned(vShowAboutForm) then begin
      vShowAboutForm(aParent);
    end;
  end;
end;

procedure TDLLAccsses.ShowMedicoForm;
var
  vShowMedicotForm : TGenericDLLAccsses;
begin
  if Self.InitializeDLL then begin
    @vShowMedicotForm := GetProcAddress(oHandle, 'ShowMedicoForm');
    if Assigned(vShowMedicotForm) then begin
      vShowMedicotForm;
    end;
  end;
end;

procedure TDLLAccsses.ShowPacientForm;
var
  vShowPacientForm : TGenericDLLAccsses;
begin
  if Self.InitializeDLL then begin
    @vShowPacientForm := GetProcAddress(oHandle, 'ShowPacienteForm');
    if Assigned(vShowPacientForm) then begin
      vShowPacientForm;
    end;
  end;
end;

procedure TDLLAccsses.ShowProntuarioForm;
var
  vShowProntuarioForm : TGenericDLLAccsses;
begin
  if Self.InitializeDLL then begin
    @vShowProntuarioForm := GetProcAddress(oHandle, 'ShowProntuarioForm');
    if Assigned(vShowProntuarioForm) then begin
      vShowProntuarioForm;
    end;
  end;
end;

end.
