unit FProntuario;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, DBGrids, ExtCtrls, StdCtrls, ComCtrls;

type
  TfrmProntuario = class(TForm)
    cmbMedico: TComboBox;
    label1: TLabel;
    Label2: TLabel;
    cmbPaciente: TComboBox;
    Label3: TLabel;
    mmoMotivo: TMemo;
    Label4: TLabel;
    DateTimePicker1: TDateTimePicker;
    btnGravar: TButton;
    Bevel1: TBevel;
    grdProntuario: TDBGrid;
    btnFechar: TButton;
    procedure btnFecharClick(Sender: TObject);
    procedure btnGravarClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure grdProntuarioCellClick(Column: TColumn);
  private
    oLstPaciente, oLstMedico : TStringList;

    procedure EncheCombo(out aLstPaciente, aLstMedico : TStringList);
  public
    { Public declarations }
  end;

var
  frmProntuario: TfrmProntuario;

implementation

uses UDM;

{$R *.dfm}

procedure TfrmProntuario.btnFecharClick(Sender: TObject);
begin
  frmProntuario.Close;
end;

procedure TfrmProntuario.btnGravarClick(Sender: TObject);
var
  vQry : string;
begin
  vQry := 'Insert into Prontuario (IdPaciente, IdMedico, Motivo, DTATENDIMENTO) '+
          ' values ('+ oLstPaciente[cmbPaciente.ItemIndex] +
          ', '+ oLstMedico[cmbMedico.ItemIndex] +', '+
          QuotedStr(mmoMotivo.Lines.Text) +', '+
          QuotedStr(FormatDateTime('yyyy-mm-dd', DateTimePicker1.DateTime))+')';

  dm.SQLConnection.Close;
  dm.SQLConnection.Execute(vQry, dm.sdsProntuario.Params);
  dm.SQLConnection.Open;
  dm.sdsProntuario.Refresh;
end;

procedure TfrmProntuario.EncheCombo(out aLstPaciente, aLstMedico: TStringList);
begin
  dm.sdsPaciente.First;
  while not dm.sdsPaciente.Eof do begin
    aLstPaciente.Add(dm.sdsPaciente.FieldByName('Id').AsString);
    cmbPaciente.Items.Add(dm.sdsPaciente.FieldByName('Nome').AsString);
    dm.sdsPaciente.Next
  end;

  dm.sdsMedico.First;
  while not dm.sdsMedico.Eof do begin
    aLstMedico.Add(dm.sdsMedico.FieldByName('Id').AsString);
    cmbMedico.Items.Add(dm.sdsMedico.FieldByName('Nome').AsString);
    dm.sdsMedico.Next
  end;
end;

procedure TfrmProntuario.FormDestroy(Sender: TObject);
begin
  oLstPaciente.Free;
  oLstMedico.Free;
end;

procedure TfrmProntuario.FormShow(Sender: TObject);
begin
  oLstPaciente := TStringList.Create;
  oLstMedico := TStringList.Create;

  Self.EncheCombo(oLstPaciente, oLstMedico);
end;

procedure TfrmProntuario.grdProntuarioCellClick(Column: TColumn);
var
  vQry : string;
begin
  vQry := 'Delete from Prontuario where Id = '+ dm.sdsProntuario.FieldByName('ID').AsString;

  dm.SQLConnection.Close;
  dm.SQLConnection.Execute(vQry, dm.sdsProntuario.Params);
  dm.SQLConnection.Open;
  dm.sdsProntuario.Refresh;
end;

end.
